=== debian/changelog ===
rccl (5.3.3-2) unstable; urgency=medium

  * Migrate to unstable.
  * d/rules: use dwarf4 debug symbols.
  * d/p/0002-expand-architecture-support.patch: update patch metadata.
  * d/librccl1.symbols: fix Build-Depends-Package lint.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 17 May 2023 12:07:24 -0600

rccl (5.3.3-1) experimental; urgency=medium

  * Initial release. (Closes: #1022889)

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 23 Apr 2023 12:37:02 -0600
