=== debian/control ===
Source: rccl
Section: devel
Homepage: https://github.com/rocmsoftwareplatform/rccl
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/rccl.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rccl
Maintainer: ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@slerp.xyz>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               hipcc,
               libamd-comgr-dev,
               libhsa-runtime-dev,
               rocminfo,
               rocm-cmake,
               librocm-smi-dev,
               liboam-dev,
               patchelf,
               chrpath <!nocheck>,
               libgtest-dev <!nocheck>
Rules-Requires-Root: no

Package: librccl1
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: ROCm Communication Collectives Library - library
 RCCL (pronounced "Rickle") is a library of collective communication routines
 built on the AMD ROCm platform and optimized for discrete AMD GPUs. It
 implements routines such as all-reduce, all-gather, reduce, broadcast,
 reduce-scatter, gather, scatter and all-to-all. The library is optimized for
 high bandwidth over channels including PCIe, xGMI, InfiniBand Verbs or TCP/IP
 sockets and supports an arbitrary number of GPUs.
 .
 This package provides the RCCL library.

Package: librccl-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librccl1 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev,
Description: ROCm Communication Collectives Library - headers
 RCCL (pronounced "Rickle") is a library of collective communication routines
 built on the AMD ROCm platform and optimized for discrete AMD GPUs. It
 implements routines such as all-reduce, all-gather, reduce, broadcast,
 reduce-scatter, gather, scatter and all-to-all. The library is optimized for
 high bandwidth over channels including PCIe, xGMI, InfiniBand Verbs or TCP/IP
 sockets and supports an arbitrary number of GPUs.
 .
 This package provides the RCCL development headers.
