=== debian/changelog ===
rccl (5.4.3-3ubuntu2) resolute; urgency=medium

  * No change rebuild for rocm-hipamd.

 -- Mario Limonciello <superm1@gmail.com>  Mon, 27 Oct 2025 12:53:27 -0500

rccl (5.4.3-3build1) plucky; urgency=medium

  * NCR to drop the execstack bit (LP: #2100297)

 -- Simon Chopin <schopin@ubuntu.com>  Tue, 18 Mar 2025 12:39:15 +0100

rccl (5.4.3-3) unstable; urgency=medium

  * Migrate to unstable.
  * d/t/upstream-binaries: skip tests if PCIe P2P is not enabled

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 13 Apr 2024 23:47:42 -0600

rccl (5.4.3-3~exp1) experimental; urgency=medium

  [ Cordell Bloor ]
  * Add librccl1-tests package for autopkgtests
  * Add librccl-doc package for documentation

  [ Christian Kastner ]
  * Add d/gbp.conf to enforce use of pristine-tar

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 12 Mar 2024 11:33:40 -0600

rccl (5.4.3-2) unstable; urgency=medium

  * Migrate to unstable

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 08 Mar 2024 17:58:45 -0700

rccl (5.4.3-2~exp1) experimental; urgency=medium

  * Enable gfx1100, gfx1101 and gfx1102 architectures
  * Update Build-Depends to require clang-17
  * Drop patchelf from Build-Depends
  * Use nocheck build profile to control build options
  * Enable verbose flag for linking

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 01 Mar 2024 20:19:55 -0700

rccl (5.4.3-1) unstable; urgency=medium

  * New upstream version 5.4.3
  * Update upstream URLs
  * Update maintainer name for consistency with other packages
  * d/rules: drop gfx1011 from build architectures.
    The HIP runtime will fall back to using gfx1010.
  * d/rules: use compressed DWARF5 debug symbols

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 16 Feb 2024 14:02:55 -0700

rccl (5.3.3-3) unstable; urgency=medium

  * Filter cf-protection hardening from device code.
    Fixes a FTBFS with dpkg >= 1.22 (Closes: #1052954)
  * Add myself to Uploaders

 -- Christian Kastner <ckk@debian.org>  Tue, 26 Sep 2023 17:55:22 +0200
