=== debian/control ===
--- 
+++ 
@@ -1,24 +1,32 @@
 Source: rccl
 Section: devel
-Homepage: https://github.com/rocmsoftwareplatform/rccl
+Homepage: https://github.com/ROCm/rccl
 Priority: optional
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/rocm-team/rccl.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/rccl
-Maintainer: ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Cordell Bloor <cgmb@slerp.xyz>,
+           Christian Kastner <ckk@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               hipcc,
-               libamd-comgr-dev,
-               libhsa-runtime-dev,
-               rocminfo,
+               hipcc (>= 5.6.1~),
+               libamd-comgr-dev (>= 6.0~),
+               libhsa-runtime-dev (>= 5.7.1~),
                rocm-cmake,
                librocm-smi-dev,
                liboam-dev,
-               patchelf,
                chrpath <!nocheck>,
                libgtest-dev <!nocheck>
+Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
+               doxygen <!nodoc>,
+               python3-breathe <!nodoc>,
+               python3-sphinx <!nodoc>,
+               python3-sphinx-rtd-theme <!nodoc>,
+               libjs-jquery <!nodoc>,
+               libjs-mathjax <!nodoc>,
+               libjs-sphinxdoc <!nodoc>,
+               libjs-underscore <!nodoc>
 Rules-Requires-Root: no
 
 Package: librccl1
@@ -40,6 +48,7 @@
 Architecture: amd64 arm64 ppc64el
 Depends: librccl1 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
          libamdhip64-dev,
+Suggests: librccl-doc
 Description: ROCm Communication Collectives Library - headers
  RCCL (pronounced "Rickle") is a library of collective communication routines
  built on the AMD ROCm platform and optimized for discrete AMD GPUs. It
@@ -49,3 +58,39 @@
  sockets and supports an arbitrary number of GPUs.
  .
  This package provides the RCCL development headers.
+
+Package: librccl1-tests
+Section: libdevel
+Architecture: amd64 arm64 ppc64el
+Depends: librccl1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
+Build-Profiles: <!nocheck>
+Description: ROCm Communication Collectives Library - tests
+ RCCL (pronounced "Rickle") is a library of collective communication routines
+ built on the AMD ROCm platform and optimized for discrete AMD GPUs. It
+ implements routines such as all-reduce, all-gather, reduce, broadcast,
+ reduce-scatter, gather, scatter and all-to-all. The library is optimized for
+ high bandwidth over channels including PCIe, xGMI, InfiniBand Verbs or TCP/IP
+ sockets and supports an arbitrary number of GPUs.
+ .
+ This package provides the RCCL test binaries used for verifying that the
+ library is functioning correctly. These binaries are only used to check whether
+ RCCL works correctly on a given GPU, so generally speaking, users probably
+ don't need this package.
+
+Package: librccl-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Build-Profiles: <!nodoc>
+Depends: ${misc:Depends},
+         ${sphinxdoc:Depends},
+         libjs-mathjax,
+Description: ROCm Communication Collectives Library - documentation
+ RCCL (pronounced "Rickle") is a library of collective communication routines
+ built on the AMD ROCm platform and optimized for discrete AMD GPUs. It
+ implements routines such as all-reduce, all-gather, reduce, broadcast,
+ reduce-scatter, gather, scatter and all-to-all. The library is optimized for
+ high bandwidth over channels including PCIe, xGMI, InfiniBand Verbs or TCP/IP
+ sockets and supports an arbitrary number of GPUs.
+ .
+ This package provides the RCCL documentation.
