=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries librccl1-tests
Depends: librccl1-tests, grep
Restrictions: skippable, allow-stderr
Architecture: amd64
