=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rccl-$1.tar.gz%" \
    https://github.com/rocm/rccl/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
